<?php 

class EmailRenderer
{
    private $templateDir;
    
    public $twig;
    
    
    public $tmeplateList = [
        
            "accountBillingInformation",
            "accountCancellationNotice",
            "accountInformationUpdated",
            "accountInstallation",
            "accountRefunded",
            "accounSubscriptionPaymentFailed"
        
        ];
    
    
    public function __construct()
    {
        $config = new Config();
        
        $loader = new Twig_Loader_Filesystem($config['templates']['templatesDirectory']);
        $this->twig = new Twig_Environment($loader);
        
    }
    
    public function renderTemplate($Tmpl, Array $Data)
    {
        // $Data is an associative array of data
        if(!in_array($this->templateList, $Tmpl))
        {
            throw new Exception("WARNING: Selected template not available");
        }
        else
        {
            return $this->twig->render($Tmpl, $Data);
        }
        
    }
}